<script lang="ts" setup>
import { AddLocation } from '@element-plus/icons-vue'

import FabriqueForm from "@/components/FabriqueForm.vue";
import type { Fabrique } from "@/entities";
import { doAndNotify } from "@/form-helpers";
import { useFabriqueStore } from "@/stores/fabrique";
import { storeToRefs } from "pinia";
import { onMounted, ref } from "vue";


const store = useFabriqueStore();
const { fabriques } = storeToRefs(store);

const selected = ref<Fabrique>();
const displayForm = ref(false);

onMounted(() => {
    store.fetchFabriques();
});

function remove(fabrique: Fabrique) {
    doAndNotify(fabrique, store.removeFabrique, 'supprimer');
    selected.value = undefined;
}

function newFabrique() {
    if (displayForm.value) {
        displayForm.value = false;
        return;
    }
    displayForm.value = true;
    selected.value = undefined;
}

</script>
    
    
<template>
    <h1>Gestion des fabriques 
        <el-button @click="newFabrique()" size="small" type="primary" :icon="AddLocation">
            Nouvelle fabrique
        </el-button>
    </h1>
    <el-card v-if="selected || displayForm">
        <h2 v-if="selected">Modifier la fabrique</h2>
        <h2 v-if="!selected">Nouvelle fabrique</h2>
        <FabriqueForm :fabrique="selected" @cancel="selected = undefined, displayForm =false" />
    </el-card>
    <h2>Liste des fabriques</h2>
    <el-row :gutter="20">
        <el-col :md="6" v-for="fabrique of fabriques" :key="fabrique.id">
            <el-card shadow="hover" class="box-card">
                <el-popconfirm title="Supprimer la fabrique ?" confirm-button-text="Oui" cancel-button-text="Non"
                    @confirm="remove(fabrique)">
                    <template #reference>
                        <el-link class="remove-button" type="danger" :underline="false">
                            <el-icon>
                                <DeleteFilled />
                            </el-icon>
                        </el-link>
                    </template>
                </el-popconfirm>
                <template #header>
                    <div class="card-header">
                        <div style="width:100%">
                            <el-row align="middle" justify="space-around">
                                <span>{{ fabrique.name }}</span>
                            </el-row>
                            <div style="text-align:right">
                                <el-tag type="info">{{ fabrique.region.name }}</el-tag>
                            </div>

                        </div>
                    </div>
                </template>

                <el-button @click="selected = fabrique">Modifier</el-button>

            </el-card>
        </el-col>
    </el-row>
</template>


<style scoped>
.el-card {
    position: relative;
    margin-bottom: 5px;
}

.remove-button {
    position: absolute;
    top: 5px;
    right: 5px;
}
</style>